<?php
namespace Neuron\Person\Controller\Widget;

use Neuron\Access\Session;

class Family extends \Neuron\Person\Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/person/layout/plain');

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/person/family';

		$config = $this->getConfig();
		if (isset($config['person'])) {
			$config = $config['person'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	public function formAction()
    {
        $this->getSession()->get();
        $post = $this->getPostParams();
        $id = $post['id'];
        $person_id = $post['person_id'];
        $famdata = array();
        $title = "Create Family";

        $storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
        $cpar = new \Neuron\Person\Parameters($storage);

        $post = $this->getPostParams();
        $arr = $cpar->listparam($post['param_ref_name']);
        $relation = array();

        if ($arr) {
            foreach ($arr as $data) {
                if($data['param_ref_name'] == 'FAMILY_RELATION'){
                    // $data['description'] = $this->translate($data['description']);
                    array_push($relation, $data);
                }
            }
        }
        if($id){
            $storage = \Neuron\Person\Family\Storage::factory($this->getDb(), $this->getConfig());
            $cfam = new \Neuron\Person\Family($storage);
            $title = "Edit Family";
            if ($cfam->load($id))  {
                $famdata = $cfam->pull();
            }
        }
        return $this->getViewPartial('crud', get_defined_vars());
    }
    
}