<?php

namespace Neuron\Person\Family\Storage;

class Mysql extends \Neuron\Db\Storage implements Skeleton {
	public function listdata($params) {
		$select = $this->select()->from(array('fam' => $this->_tables['person_family']));
		$select->join(array('pp'=> $this->_tables['person_parameters']), $this->expression("(pp.param_ref_name = 'FAMILY_RELATION' AND fam.family_position = pp.value1)"), array('param_ref_id'), 'left');

	    if ((!empty($params['person_id']))) {
	      	$select->where(array('fam.person_id' => $params['person_id'], 'fam.end_date IS NULL'));
	    }
	    if(isset($params['order'][0]['column']) && !empty($params['order'][0]['column'])){
			$i = $params['order'][0]['column'];
			$dir = $params['order'][0]['dir'];
			$select->order(array($params['columns'][$i]['data'] . " " . $dir));
		}
		
		if(isset($params['length']) && !empty($params['length'])){
			$select->limit(intval($params['length']));
			$select->offset(intval($params['start']));
		}
		
		$data = $this->fetchAll($select);
		$dataAll = [];

		if($data) {
			foreach($data as $row) {
				array_push($dataAll, $row);
			}
		}

	    // echo str_replace('"','',$select->getSqlString())."<br />"; die();
	    $selectC = $this->select()->from(array('fam' => $this->_tables['person_family']));
	    $select->join(array('pp'=> $this->_tables['person_parameters']), $this->expression("(pp.param_ref_name = 'FAMILY_RELATION' AND fam.family_position = pp.value1)"), array(), 'left');
        $selectC->columns(['total_count' => new \Zend\Db\Sql\Expression('COUNT(*)')]);
        if ((!empty($params['person_id']))) {
	      	$selectC->where(array('fam.person_id' => $params['person_id'], 'fam.end_date IS NULL'));
	    }
        $dataCount = $this->fetchRow($selectC);

        $total = ($dataCount['total_count'] > 0) ? $dataCount['total_count']:0;
                        
        $result = ['data' => $dataAll, 'total' => $total];
        
        return $result;

	    // return $this->fetchAll($select);
  	}

	public function load($perFamId) {
		try{
		    $select = $this->select()
		                    ->from($this->_tables['person_family'])
		                    ->where(array('family_id' => $perFamId));

		    return $this->fetchRow($select);
	    }catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function save(\Neuron\Person\Family $perFam, $update = false) {
		try{
		    if ($update) {
		      
		      $update = $this->update()
		        ->table($this->_tables['person_family'])
		        ->set($this->__(array(
                                    'full_name' => $perFam->full_name,
                                    'identity_number' => $perFam->identity_number,
                                    'gender' => $perFam->gender,
                                    'birth_place' => $perFam->birth_place,
                                    'birth_date' => $perFam->birth_date,
                                    'education' => $perFam->education,
                                    'occupation' => $perFam->occupation,
                                    'marital_status' => $perFam->marital_status,
                                    'family_position' => $perFam->family_position
                                    )))
		        ->where($this->__(array('family_id' => $perFam->family_id)));

		      // echo str_replace('"','',$update->getSqlString()).'<br />';
		      if ($this->execute($update)) {
		          return $perFam->family_id;
		      }
		      
		    } else {

		      $insert = $this->insert()
		        ->into($this->_tables['person_family'])
				->values($this->__($perFam->pull()));
				echo str_replace('"','',$insert->getSqlString()).'<br />';  
				
		      $save = $this->execute($insert);
		      if ($save) {
		          $perFam->family_id = $save;
		          return $perFam->family_id;
		      }
		    }

		    return false;
		}catch(\Exception $e){
			return $e->getMessage();
		}
  	}

	public function remove($perFamId) {
		try{
			$delete = $this->delete()
	                    ->from($this->_tables['person_family'])
	                    ->where(array('family_id' => $perFamId));
	                
	    	return $this->execute($delete);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}

	public function loadRelation(){
		try{
			$select = $this->select()
                   ->columns(array('value'=>'param_ref_id','name'=>'description',))
                   ->from('person_parameters')
                   ->where("upper(param_ref_name) = 'FAMILY_RELATION'");
    
	    	// echo str_replace('"','',$select->getSqlString())."<br />";
			return $this->fetchAll($select);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
}