<?php
namespace Neuron\Person;

use \Neuron\Application\Framework as NAF;

class Generic{
    protected $_cacheDir;
    
    public function __construct(){
        $naf    = NAF\Entity::get();
        $this->_cacheDir = getcwd().'/cache/person/';
        if(!file_exists($this->_cacheDir)){
            mkdir($this->_cacheDir);
        }
    }

    public function getCacheAdapter(){
		$cache 		= \Zend\Cache\StorageFactory::factory(array(
			'adapter' 	=> array(
				'name' 		=> 'filesystem',
				'options' 	=> array(
					'ttl' 			=> 1440,
					'cache_dir'		=> $this->_cacheDir
				),
			),
			'plugins' 	=> array(
				'exception_handler' 	=> array('throw_exceptions' => false)
			)
        ));
        $cache->clearExpired();
        return $cache;
    }

    public function clearCache($cacheHash){
        $cache  = $this->getCacheAdapter();
        return $cache->removeItem($cacheHash);
    }


}